//+------------------------------------------------------------------+
//|                                      #MTF Stochastic Thread.mq4  |
//|                                                                  |
//|     Based on Spudfyre's Thread theory                            |
//|                                                                  |
//|                                                            emda  |
//+------------------------------------------------------------------+

#property copyright "Copyright  2007, Emda"
#property link "http://www.forexfactory.com/showthread.php?t=37111"
//----
#property indicator_separate_window
#property indicator_minimum -30
#property indicator_maximum 100
#property indicator_buffers 8
#property indicator_color1 IndianRed
#property indicator_color2 IndianRed
#property indicator_color3 IndianRed
#property indicator_color4 IndianRed
#property indicator_color5 IndianRed
#property indicator_color6 IndianRed
#property indicator_color7 IndianRed
#property indicator_color8 Red
#property indicator_width8 1
#property indicator_level1 23.6
#property indicator_level2 76.4
#property indicator_level3 50
#property indicator_level4 0
#property indicator_levelcolor Gray



string version="1.05";

//---- input parameters
extern string coment1 = "--- stoch wall params ------";
extern int Periodwall = 14;
extern int Slowing = 3;
extern int MaxTF = 24;
extern int Numbars = 0;

//---- buffers
double Bufferh1[];
double Bufferh2[];
double Bufferh3[];
double Bufferh4[];
double Bufferh5[];
double Bufferh6[];
double Bufferh7[];
double Bufferh8[];

double Periodh1,Periodh2,Periodh3,Periodh4,Periodh5,Periodh6,Periodh7,Periodh8;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(8);
//---- indicator lines
//   SetIndexStyle(0, DRAW_LINE);
//   SetIndexBuffer(0, Bufferwall);
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, Bufferh1);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(1, Bufferh2);
   SetIndexStyle(2, DRAW_LINE);
   SetIndexBuffer(2, Bufferh3);
   SetIndexStyle(3, DRAW_LINE);
   SetIndexBuffer(3, Bufferh4);
   SetIndexStyle(4, DRAW_LINE);
   SetIndexBuffer(4, Bufferh5);
   SetIndexStyle(5, DRAW_LINE);
   SetIndexBuffer(5, Bufferh6);
   SetIndexStyle(6, DRAW_LINE);
   SetIndexBuffer(6, Bufferh7);
   SetIndexStyle(7, DRAW_LINE);
   SetIndexBuffer(7, Bufferh8);
   
//   SetIndexStyle(7, DRAW_HISTOGRAM);
//   SetIndexBuffer(7, BufferDeploymentH);
   
//---- name for DataWindow and indicator subwindow label
   string short_name;
   short_name="HTFS v" + version;
   IndicatorShortName(short_name);
   return(0);
}

int deinit()
{
   return(0);
}


int start()
  {

int counted_bars=IndicatorCounted();
//---- check for possible errors
if (counted_bars<0) return(-1);
//---- last counted bar will be recounted
if (counted_bars>0) counted_bars--;
int pos;
if (counted_bars==0) {
   if (Numbars==0) Numbars=Bars;
   pos=Numbars;
}else{
   pos=Bars-counted_bars;
}

//---- main calculation loop
while(pos>=0)
{
 
      int hrange = MaxTF - Periodwall;
      Periodh1 = Periodwall + (hrange / 8);
      Periodh2 = Periodwall + ((hrange * 2) / 8);
      Periodh3 = Periodwall + ((hrange * 3) / 8);
      Periodh4 = Periodwall + ((hrange * 4) / 8);
      Periodh5 = Periodwall + ((hrange * 5) / 8);
      Periodh6 = Periodwall + ((hrange * 6) / 8);
      Periodh7 = Periodwall + ((hrange * 7) / 8);
      Periodh8 = Periodwall + ((hrange * 8) / 8);
 
      double sh1 = iStochastic(NULL,0,Periodh1,3,Slowing,0,0,0,pos);
      double sh2 = iStochastic(NULL,0,Periodh2,3,Slowing,0,0,0,pos);
      double sh3 = iStochastic(NULL,0,Periodh3,3,Slowing,0,0,0,pos);
      double sh4 = iStochastic(NULL,0,Periodh4,3,Slowing,0,0,0,pos);
      double sh5 = iStochastic(NULL,0,Periodh5,3,Slowing,0,0,0,pos);
      double sh6 = iStochastic(NULL,0,Periodh6,3,Slowing,0,0,0,pos);
      double sh7 = iStochastic(NULL,0,Periodh7,3,Slowing,0,0,0,pos);
      double sh8 = iStochastic(NULL,0,Periodh8,3,Slowing,0,0,0,pos);
      Bufferh1[pos]= sh1;
      Bufferh2[pos]= sh2;
      Bufferh3[pos]= sh3;
      Bufferh4[pos]= sh4;
      Bufferh5[pos]= sh5;
      Bufferh6[pos]= sh6;
      Bufferh7[pos]= sh7;
      Bufferh8[pos]= sh8;
        
      pos--;
}

 
//----
   return(0);
   
   
  }
//+------------------------------------------------------------------+