//+------------------------------------------------------------------+
//|                                      #MTF Stochastic Thread.mq4  |
//|                                                                  |
//|     Based on Spudfyre's Thread theory                            |
//|                                                                  |
//|                                                            emda  |
//+------------------------------------------------------------------+

#property copyright "Copyright  2007, Emda"
#property link "http://www.forexfactory.com/showthread.php?t=37111"
//----
#property indicator_separate_window
#property indicator_minimum -30
#property indicator_maximum 100
#property indicator_buffers 8
#property indicator_color1 DodgerBlue
#property indicator_color2 DodgerBlue
#property indicator_color3 DodgerBlue
#property indicator_color4 DodgerBlue
#property indicator_color5 DodgerBlue
#property indicator_color6 DodgerBlue
#property indicator_color7 DodgerBlue
#property indicator_color8 Blue
#property indicator_width8 1
#property indicator_level1 23.6
#property indicator_level2 76.4
#property indicator_level3 50
#property indicator_level4 0
#property indicator_levelcolor Gray



string version="1.05";

//---- input parameters
extern string coment1 = "--- stoch wall params ------";
extern int Periodwall = 14;
extern int Slowing = 3;
extern int MinTF = 6;
extern int Numbars = 0;

//---- buffers
double Bufferl1[];
double Bufferl2[];
double Bufferl3[];
double Bufferl4[];
double Bufferl5[];
double Bufferl6[];
double Bufferl7[];
double Bufferl8[];

double Periodl1,Periodl2,Periodl3,Periodl4,Periodl5,Periodl6,Periodl7,Periodl8;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(8);
//---- indicator lines
//   SetIndexStyle(0, DRAW_LINE);
//   SetIndexBuffer(0, Bufferwall);
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, Bufferl1);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(1, Bufferl2);
   SetIndexStyle(2, DRAW_LINE);
   SetIndexBuffer(2, Bufferl3);
   SetIndexStyle(3, DRAW_LINE);
   SetIndexBuffer(3, Bufferl4);
   SetIndexStyle(4, DRAW_LINE);
   SetIndexBuffer(4, Bufferl5);
   SetIndexStyle(5, DRAW_LINE);
   SetIndexBuffer(5, Bufferl6);
   SetIndexStyle(6, DRAW_LINE);
   SetIndexBuffer(6, Bufferl7);
   SetIndexStyle(7, DRAW_LINE);
   SetIndexBuffer(7, Bufferl8);
   
//   SetIndexStyle(7, DRAW_HISTOGRAM);
//   SetIndexBuffer(7, BufferDeploymentH);
   
//---- name for DataWindow and indicator subwindow label
   string short_name;
   short_name="LTFS v" + version;
   IndicatorShortName(short_name);
   return(0);
}

int deinit()
{
   return(0);
}


int start()
  {

int counted_bars=IndicatorCounted();
//---- check for possible errors
if (counted_bars<0) return(-1);
//---- last counted bar will be recounted
if (counted_bars>0) counted_bars--;
int pos;
if (counted_bars==0) {
   if (Numbars==0) Numbars=Bars;
   pos=Numbars;
}else{
   pos=Bars-counted_bars;
}


//---- main calculation loop
while(pos>=0)
{
 
      int lrange = Periodwall - MinTF;
      Periodl1 = Periodwall - (lrange / 8);
      Periodl2 = Periodwall - ((lrange * 2) / 8);
      Periodl3 = Periodwall - ((lrange * 3) / 8);
      Periodl4 = Periodwall - ((lrange * 4) / 8);
      Periodl5 = Periodwall - ((lrange * 5) / 8);
      Periodl6 = Periodwall - ((lrange * 6) / 8);
      Periodl7 = Periodwall - ((lrange * 7) / 8);
      Periodl8 = Periodwall - ((lrange * 8) / 8);
 if (MinTF<=5){
      Periodl7--;
      Periodl6--;
      Periodl5--;
      Periodl4--;
      Periodl3--;
      Periodl2--;
      Periodl1--;
 }
      double sl1 = iStochastic(NULL,0,Periodl1,3,Slowing,0,0,0,pos);
      double sl2 = iStochastic(NULL,0,Periodl2,3,Slowing,0,0,0,pos);
      double sl3 = iStochastic(NULL,0,Periodl3,3,Slowing,0,0,0,pos);
      double sl4 = iStochastic(NULL,0,Periodl4,3,Slowing,0,0,0,pos);
      double sl5 = iStochastic(NULL,0,Periodl5,3,Slowing,0,0,0,pos);
      double sl6 = iStochastic(NULL,0,Periodl6,3,Slowing,0,0,0,pos);
      double sl7 = iStochastic(NULL,0,Periodl7,3,Slowing,0,0,0,pos);
      double sl8 = iStochastic(NULL,0,Periodl8,3,Slowing,0,0,0,pos);
      Bufferl1[pos]= sl1;
      Bufferl2[pos]= sl2;
      Bufferl3[pos]= sl3;
      Bufferl4[pos]= sl4;
      Bufferl5[pos]= sl5;
      Bufferl6[pos]= sl6;
      Bufferl7[pos]= sl7;
      Bufferl8[pos]= sl8;

      pos--;
}

 
//----
   return(0);
   
   
  }
//+------------------------------------------------------------------+