//+------------------------------------------------------------------+
//|                                      #MTF Stochastic Thread.mq4  |
//|                                                                  |
//|     Based on Spudfyre's Thread theory                            |
//|                                                                  |
//|                                                            emda  |
//+------------------------------------------------------------------+

#property copyright "Copyright  2007, Emda"
#property link "http://www.forexfactory.com/showthread.php?t=37111"
//----
#property indicator_separate_window
#property indicator_minimum -30
#property indicator_maximum 100

#property indicator_buffers 5

#property indicator_color1 RoyalBlue
#property indicator_width1 20
#property indicator_color2 Tomato
#property indicator_width2 20
#property indicator_color3 Gold
#property indicator_width3 3
#property indicator_color4 LimeGreen
#property indicator_width4 3
#property indicator_color5 LimeGreen
#property indicator_width5 3

#property indicator_level1 23.6
#property indicator_level2 76.4
#property indicator_level3 50
#property indicator_level4 0
#property indicator_levelcolor Gray



string version="1.05";

//---- input parameters
extern string coment1 = "--- stoch wall params ------";
extern int Periodwall = 14;
extern int Slowing = 3;
extern int MinTF = 6;
extern int MaxTF = 24;
extern int MinElasticity = 20;
extern double ElasticityScaleL = 1.5;
extern double ElasticityScaleH = 1.5;
extern double DeploymentScale = 2.0;
extern string coment2 = "--- display params ------";
extern bool SeeWall = true;
extern bool SeeAverageWall = false;
extern int Numbars = 0;

//---- buffers
double BufferWall[];
double BufferAverage[];
double BufferDeploymentL[];
double BufferDeploymentH[];
double BufferElasticity[];

double Periodl1,Periodl2,Periodl3,Periodl4,Periodl5,Periodl6,Periodl7,Periodl8;
double Periodh1,Periodh2,Periodh3,Periodh4,Periodh5,Periodh6,Periodh7,Periodh8;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(5);
//---- indicator lines
   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(0, BufferDeploymentL);
   SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(1, BufferDeploymentH);
   SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexBuffer(2, BufferElasticity);   
   SetIndexStyle(3, DRAW_LINE);
   SetIndexBuffer(3, BufferWall);
   SetIndexStyle(4, DRAW_LINE);
   SetIndexBuffer(4, BufferAverage);

//---- name for DataWindow and indicator subwindow label
   string short_name;
   short_name="Stochastic Deployment and Elasticity v" + version;
   IndicatorShortName(short_name);
   SetIndexLabel(0, "Deployment LTFS " + Periodwall);
   SetIndexLabel(1, "Deployment HTFS " + Periodwall);
   SetIndexLabel(2, "Elasticity");
   SetIndexLabel(3, "WALL " + Periodwall);
   SetIndexLabel(4, "AverageWall " + Periodwall);

   return(0);
   
}

int deinit()
{
   return(0);
}


int start()
  {

int counted_bars=IndicatorCounted();
//---- check for possible errors
if (counted_bars<0) return(-1);
//---- last counted bar will be recounted
if (counted_bars>0) counted_bars--;
int pos;
if (counted_bars==0) {
   if (Numbars==0) Numbars=Bars;
   pos=Numbars;
}else{
   pos=Bars-counted_bars;
}


//---- main calculation loop
while(pos>=0)
{
 
      int lrange = Periodwall - MinTF;
      Periodl1 = Periodwall - (lrange / 8);
      Periodl2 = Periodwall - ((lrange * 2) / 8);
      Periodl3 = Periodwall - ((lrange * 3) / 8);
      Periodl4 = Periodwall - ((lrange * 4) / 8);
      Periodl5 = Periodwall - ((lrange * 5) / 8);
      Periodl6 = Periodwall - ((lrange * 6) / 8);
      Periodl7 = Periodwall - ((lrange * 7) / 8);
      Periodl8 = Periodwall - ((lrange * 8) / 8);
 
     int hrange = MaxTF - Periodwall;
      Periodh1 = Periodwall + (hrange / 8);
      Periodh2 = Periodwall + ((hrange * 2) / 8);
      Periodh3 = Periodwall + ((hrange * 3) / 8);
      Periodh4 = Periodwall + ((hrange * 4) / 8);
      Periodh5 = Periodwall + ((hrange * 5) / 8);
      Periodh6 = Periodwall + ((hrange * 6) / 8);
      Periodh7 = Periodwall + ((hrange * 7) / 8);
      Periodh8 = Periodwall + ((hrange * 8) / 8);
     
      double swall = iStochastic(NULL,0,Periodwall,3,Slowing,0,0,0,pos);
      
      
      double sl1 = iStochastic(NULL,0,Periodl1,3,Slowing,0,0,0,pos);
      double sl2 = iStochastic(NULL,0,Periodl2,3,Slowing,0,0,0,pos);
      double sl3 = iStochastic(NULL,0,Periodl3,3,Slowing,0,0,0,pos);
      double sl4 = iStochastic(NULL,0,Periodl4,3,Slowing,0,0,0,pos);
      double sl5 = iStochastic(NULL,0,Periodl5,3,Slowing,0,0,0,pos);
      double sl6 = iStochastic(NULL,0,Periodl6,3,Slowing,0,0,0,pos);
      double sl7 = iStochastic(NULL,0,Periodl7,3,Slowing,0,0,0,pos);
      double sl8 = iStochastic(NULL,0,Periodl8,3,Slowing,0,0,0,pos);

      double sh1 = iStochastic(NULL,0,Periodh1,3,Slowing,0,0,0,pos);
      double sh2 = iStochastic(NULL,0,Periodh2,3,Slowing,0,0,0,pos);
      double sh3 = iStochastic(NULL,0,Periodh3,3,Slowing,0,0,0,pos);
      double sh4 = iStochastic(NULL,0,Periodh4,3,Slowing,0,0,0,pos);
      double sh5 = iStochastic(NULL,0,Periodh5,3,Slowing,0,0,0,pos);
      double sh6 = iStochastic(NULL,0,Periodh6,3,Slowing,0,0,0,pos);
      double sh7 = iStochastic(NULL,0,Periodh7,3,Slowing,0,0,0,pos);
      double sh8 = iStochastic(NULL,0,Periodh8,3,Slowing,0,0,0,pos);

      
      double lmatrix[9];
      lmatrix[0]=swall;
      lmatrix[1]=sl1;
      lmatrix[2]=sl2;
      lmatrix[3]=sl3;
      lmatrix[4]=sl4;
      lmatrix[5]=sl5;
      lmatrix[6]=sl6;
      lmatrix[7]=sl7;
      lmatrix[8]=sl8;
      double hmatrix[9];
      hmatrix[0]=swall;
      hmatrix[1]=sh1;
      hmatrix[2]=sh2;
      hmatrix[3]=sh3;
      hmatrix[4]=sh4;
      hmatrix[5]=sh5;
      hmatrix[6]=sh6;
      hmatrix[7]=sh7;
      hmatrix[8]=sh8;
      double maxstochl = lmatrix[ArrayMaximum(lmatrix)];
      double minstochl = lmatrix[ArrayMinimum(lmatrix)];
      double maxstochh = hmatrix[ArrayMaximum(hmatrix)];
      double minstochh = hmatrix[ArrayMinimum(hmatrix)];
      
      if (SeeWall) BufferWall[pos]= swall;
      
      if (SeeAverageWall){
         double average = (sh1+sh2+sh3+sh4+sh5+sh6+sh7+sh8+swall+sl1+sl2+sl3+sl4+sl5+sl6+sl7+sl8)/17;
         BufferAverage[pos]= average;      
      }
      
      
      double deploymentL = maxstochl-minstochl;
      double deploymentH = maxstochh-minstochh;
      BufferDeploymentL[pos]= 0-(deploymentL/DeploymentScale);
      BufferDeploymentH[pos]= deploymentH/DeploymentScale;
      
      double elasticity = deploymentL - deploymentH ;
      if ((elasticity > MinElasticity) || (elasticity < (0 - MinElasticity)))
      {
      if (elasticity > 0) BufferElasticity[pos]= elasticity / ElasticityScaleL; else BufferElasticity[pos]= elasticity / ElasticityScaleH;
      }else{
      BufferElasticity[pos]= 0;
      }
      
      pos--;
}

 
//----
   return(0);
   
   
  }
//+------------------------------------------------------------------+